import java.io.*;
import java.text.*;
import java.util.Vector;
import java.util.Date;

public class ChangeDate {
 private int sort ; // 0 = most recent date, 1= oldest date
 private long computedDate;
 private long oldDate;
 
 public ChangeDate(String defaultSort) {
  sort= Integer.parseInt(defaultSort);
 }

 public ChangeDate(int defaultSort) {
  sort= defaultSort;
 }

 public ChangeDate() {
  // default value for sort
  this(0);
 }

 private boolean compare(long date1, long date2) {
  if (sort==0)
   return (date1<date2);
 else
  return (date1>date2);
 }

 public long getDeepDate(String name,long baseDate) {
  File currentFile = new File(name);
  if (!currentFile.isDirectory()) { // FileName
    return currentFile.lastModified();
  } else {
    String[] children = currentFile.list();
       long computedDate = baseDate;
        for (int i=0; i<children.length; i++) {
         long currentDate = getDeepDate(currentFile.getAbsolutePath()  + "\\" + children[i],baseDate);
            if (compare(computedDate,currentDate))
             computedDate = currentDate;
        } 
        currentFile.setLastModified(computedDate);
        return computedDate;
}
  }
 
 public int directoryTravers(String name) {
  File dirName = new File(name);
  oldDate = dirName.lastModified();
  computedDate = getDeepDate(name,oldDate);
 if (!dirName.exists()) System.out.println("exist NOK");
 if (!dirName.canWrite()) System.out.println("write NOK");
 if (!dirName.canRead()) System.out.println("read NOK");
 if (!dirName.setLastModified(computedDate)) System.out.println("NOK Date");
 return 0;
 }

public long getNewDate() {
 return computedDate;
}

public long getOldDate() {
 return oldDate;
}

 public static void main(String[] args) {
  System.out.println("Source Directory : " + args [0]);
  ChangeDate cd = new ChangeDate(args[1]); // 0 = most recent date, 1= oldest date
  cd.directoryTravers(args[0]);
  System.out.println("Old Date : " + DateFormat.getDateTimeInstance().format(new Date(cd.getOldDate())));
  System.out.println("New Date : " + DateFormat.getDateTimeInstance().format(new Date(cd.getNewDate())));
 }
}
